import { ZonedDateTime as b, CalendarDateTime as C, CalendarDate as U } from "./ui-components-library296.js";
import { constrain as M } from "./ui-components-library297.js";
import { GregorianCalendar as h, getExtendedYear as p } from "./ui-components-library299.js";
import { getLocalTimeZone as y } from "./ui-components-library80.js";
function u(e) {
  e = $(e, new h());
  let t = p(e.era, e.year);
  return T(t, e.month, e.day, e.hour, e.minute, e.second, e.millisecond);
}
function T(e, t, n, r, o, a, c) {
  let f = /* @__PURE__ */ new Date();
  return f.setUTCHours(r, o, a, c), f.setUTCFullYear(e, t - 1, n), f.getTime();
}
function s(e, t) {
  if (t === "UTC") return 0;
  if (e > 0 && t === y()) return new Date(e).getTimezoneOffset() * -6e4;
  let { year: n, month: r, day: o, hour: a, minute: c, second: f } = D(e, t);
  return T(n, r, o, a, c, f, 0) - Math.floor(e / 1e3) * 1e3;
}
const m = /* @__PURE__ */ new Map();
function D(e, t) {
  let n = m.get(t);
  n || (n = new Intl.DateTimeFormat("en-US", {
    timeZone: t,
    hour12: !1,
    era: "short",
    year: "numeric",
    month: "numeric",
    day: "numeric",
    hour: "numeric",
    minute: "numeric",
    second: "numeric"
  }), m.set(t, n));
  let r = n.formatToParts(new Date(e)), o = {};
  for (let a of r) a.type !== "literal" && (o[a.type] = a.value);
  return {
    // Firefox returns B instead of BC... https://bugzilla.mozilla.org/show_bug.cgi?id=1752253
    year: o.era === "BC" || o.era === "B" ? -o.year + 1 : +o.year,
    month: +o.month,
    day: +o.day,
    hour: o.hour === "24" ? 0 : +o.hour,
    minute: +o.minute,
    second: +o.second
  };
}
const d = 864e5;
function v(e, t, n, r) {
  return (n === r ? [
    n
  ] : [
    n,
    r
  ]).filter((a) => F(e, t, a));
}
function F(e, t, n) {
  let r = D(n, t);
  return e.year === r.year && e.month === r.month && e.day === r.day && e.hour === r.hour && e.minute === r.minute && e.second === r.second;
}
function x(e, t, n = "compatible") {
  let r = A(e);
  if (t === "UTC") return u(r);
  if (t === y() && n === "compatible") {
    r = $(r, new h());
    let l = /* @__PURE__ */ new Date(), i = p(r.era, r.year);
    return l.setFullYear(i, r.month - 1, r.day), l.setHours(r.hour, r.minute, r.second, r.millisecond), l.getTime();
  }
  let o = u(r), a = s(o - d, t), c = s(o + d, t), f = v(r, t, o - a, o - c);
  if (f.length === 1) return f[0];
  if (f.length > 1) switch (n) {
    // 'compatible' means 'earlier' for "fall back" transitions
    case "compatible":
    case "earlier":
      return f[0];
    case "later":
      return f[f.length - 1];
    case "reject":
      throw new RangeError("Multiple possible absolute times found");
  }
  switch (n) {
    case "earlier":
      return Math.min(o - a, o - c);
    // 'compatible' means 'later' for "spring forward" transitions
    case "compatible":
    case "later":
      return Math.max(o - a, o - c);
    case "reject":
      throw new RangeError("No such absolute time found");
  }
}
function I(e, t, n = "compatible") {
  return new Date(x(e, t, n));
}
function g(e, t) {
  let n = s(e, t), r = new Date(e + n), o = r.getUTCFullYear(), a = r.getUTCMonth() + 1, c = r.getUTCDate(), f = r.getUTCHours(), l = r.getUTCMinutes(), i = r.getUTCSeconds(), w = r.getUTCMilliseconds();
  return new b(o < 1 ? "BC" : "AD", o < 1 ? -o + 1 : o, a, c, t, n, f, l, i, w);
}
function L(e) {
  return new U(e.calendar, e.era, e.year, e.month, e.day);
}
function A(e, t) {
  let n = 0, r = 0, o = 0, a = 0;
  if ("timeZone" in e) ({ hour: n, minute: r, second: o, millisecond: a } = e);
  else if ("hour" in e && !t) return e;
  return t && ({ hour: n, minute: r, second: o, millisecond: a } = t), new C(e.calendar, e.era, e.year, e.month, e.day, n, r, o, a);
}
function $(e, t) {
  if (e.calendar.identifier === t.identifier) return e;
  let n = t.fromJulianDay(e.calendar.toJulianDay(e)), r = e.copy();
  return r.calendar = t, r.era = n.era, r.year = n.year, r.month = n.month, r.day = n.day, M(r), r;
}
function S(e, t, n) {
  if (e instanceof b)
    return e.timeZone === t ? e : B(e, t);
  let r = x(e, t, n);
  return g(r, t);
}
function j(e) {
  let t = u(e) - e.offset;
  return new Date(t);
}
function B(e, t) {
  let n = u(e) - e.offset;
  return $(g(n, t), e.calendar);
}
export {
  u as epochFromDate,
  g as fromAbsolute,
  s as getTimeZoneOffset,
  x as toAbsolute,
  $ as toCalendar,
  L as toCalendarDate,
  A as toCalendarDateTime,
  I as toDate,
  B as toTimeZone,
  S as toZoned,
  j as zonedToDate
};
