import { Selection as n } from "./ui-components-library353.js";
import { compareNodeOrder as r, getFirstItem as d, getChildNodes as u } from "./ui-components-library355.js";
class h {
  /**
  * The type of selection that is allowed in the collection.
  */
  get selectionMode() {
    return this.state.selectionMode;
  }
  /**
  * Whether the collection allows empty selection.
  */
  get disallowEmptySelection() {
    return this.state.disallowEmptySelection;
  }
  /**
  * The selection behavior for the collection.
  */
  get selectionBehavior() {
    return this.state.selectionBehavior;
  }
  /**
  * Sets the selection behavior for the collection.
  */
  setSelectionBehavior(t) {
    this.state.setSelectionBehavior(t);
  }
  /**
  * Whether the collection is currently focused.
  */
  get isFocused() {
    return this.state.isFocused;
  }
  /**
  * Sets whether the collection is focused.
  */
  setFocused(t) {
    this.state.setFocused(t);
  }
  /**
  * The current focused key in the collection.
  */
  get focusedKey() {
    return this.state.focusedKey;
  }
  /** Whether the first or last child of the focused key should receive focus. */
  get childFocusStrategy() {
    return this.state.childFocusStrategy;
  }
  /**
  * Sets the focused key.
  */
  setFocusedKey(t, e) {
    (t == null || this.collection.getItem(t)) && this.state.setFocusedKey(t, e);
  }
  /**
  * The currently selected keys in the collection.
  */
  get selectedKeys() {
    return this.state.selectedKeys === "all" ? new Set(this.getSelectAllKeys()) : this.state.selectedKeys;
  }
  /**
  * The raw selection value for the collection.
  * Either 'all' for select all, or a set of keys.
  */
  get rawSelection() {
    return this.state.selectedKeys;
  }
  /**
  * Returns whether a key is selected.
  */
  isSelected(t) {
    if (this.state.selectionMode === "none") return !1;
    let e = this.getKey(t);
    return e == null ? !1 : this.state.selectedKeys === "all" ? this.canSelectItem(e) : this.state.selectedKeys.has(e);
  }
  /**
  * Whether the selection is empty.
  */
  get isEmpty() {
    return this.state.selectedKeys !== "all" && this.state.selectedKeys.size === 0;
  }
  /**
  * Whether all items in the collection are selected.
  */
  get isSelectAll() {
    if (this.isEmpty) return !1;
    if (this.state.selectedKeys === "all") return !0;
    if (this._isSelectAll != null) return this._isSelectAll;
    let t = this.getSelectAllKeys(), e = this.state.selectedKeys;
    return this._isSelectAll = t.every((l) => e.has(l)), this._isSelectAll;
  }
  get firstSelectedKey() {
    let t = null;
    for (let l of this.state.selectedKeys) {
      let s = this.collection.getItem(l);
      (!t || s && r(this.collection, s, t) < 0) && (t = s);
    }
    var e;
    return (e = t == null ? void 0 : t.key) !== null && e !== void 0 ? e : null;
  }
  get lastSelectedKey() {
    let t = null;
    for (let l of this.state.selectedKeys) {
      let s = this.collection.getItem(l);
      (!t || s && r(this.collection, s, t) > 0) && (t = s);
    }
    var e;
    return (e = t == null ? void 0 : t.key) !== null && e !== void 0 ? e : null;
  }
  get disabledKeys() {
    return this.state.disabledKeys;
  }
  get disabledBehavior() {
    return this.state.disabledBehavior;
  }
  /**
  * Extends the selection to the given key.
  */
  extendSelection(t) {
    if (this.selectionMode === "none") return;
    if (this.selectionMode === "single") {
      this.replaceSelection(t);
      return;
    }
    let e = this.getKey(t);
    if (e == null) return;
    let l;
    if (this.state.selectedKeys === "all") l = new n([
      e
    ], e, e);
    else {
      let i = this.state.selectedKeys;
      var s;
      let a = (s = i.anchorKey) !== null && s !== void 0 ? s : e;
      l = new n(i, a, e);
      var o;
      for (let c of this.getKeyRange(a, (o = i.currentKey) !== null && o !== void 0 ? o : e)) l.delete(c);
      for (let c of this.getKeyRange(e, a)) this.canSelectItem(c) && l.add(c);
    }
    this.state.setSelectedKeys(l);
  }
  getKeyRange(t, e) {
    let l = this.collection.getItem(t), s = this.collection.getItem(e);
    return l && s ? r(this.collection, l, s) <= 0 ? this.getKeyRangeInternal(t, e) : this.getKeyRangeInternal(e, t) : [];
  }
  getKeyRangeInternal(t, e) {
    var l;
    if (!((l = this.layoutDelegate) === null || l === void 0) && l.getKeyRange) return this.layoutDelegate.getKeyRange(t, e);
    let s = [], o = t;
    for (; o != null; ) {
      let i = this.collection.getItem(o);
      if (i && (i.type === "item" || i.type === "cell" && this.allowsCellSelection) && s.push(o), o === e) return s;
      o = this.collection.getKeyAfter(o);
    }
    return [];
  }
  getKey(t) {
    let e = this.collection.getItem(t);
    if (!e || e.type === "cell" && this.allowsCellSelection) return t;
    for (; e && e.type !== "item" && e.parentKey != null; ) e = this.collection.getItem(e.parentKey);
    return !e || e.type !== "item" ? null : e.key;
  }
  /**
  * Toggles whether the given key is selected.
  */
  toggleSelection(t) {
    if (this.selectionMode === "none") return;
    if (this.selectionMode === "single" && !this.isSelected(t)) {
      this.replaceSelection(t);
      return;
    }
    let e = this.getKey(t);
    if (e == null) return;
    let l = new n(this.state.selectedKeys === "all" ? this.getSelectAllKeys() : this.state.selectedKeys);
    l.has(e) ? l.delete(e) : this.canSelectItem(e) && (l.add(e), l.anchorKey = e, l.currentKey = e), !(this.disallowEmptySelection && l.size === 0) && this.state.setSelectedKeys(l);
  }
  /**
  * Replaces the selection with only the given key.
  */
  replaceSelection(t) {
    if (this.selectionMode === "none") return;
    let e = this.getKey(t);
    if (e == null) return;
    let l = this.canSelectItem(e) ? new n([
      e
    ], e, e) : new n();
    this.state.setSelectedKeys(l);
  }
  /**
  * Replaces the selection with the given keys.
  */
  setSelectedKeys(t) {
    if (this.selectionMode === "none") return;
    let e = new n();
    for (let l of t) {
      let s = this.getKey(l);
      if (s != null && (e.add(s), this.selectionMode === "single"))
        break;
    }
    this.state.setSelectedKeys(e);
  }
  getSelectAllKeys() {
    let t = [], e = (l) => {
      for (; l != null; ) {
        if (this.canSelectItem(l)) {
          var s;
          let i = this.collection.getItem(l);
          (i == null ? void 0 : i.type) === "item" && t.push(l);
          var o;
          i != null && i.hasChildNodes && (this.allowsCellSelection || i.type !== "item") && e((o = (s = d(u(i, this.collection))) === null || s === void 0 ? void 0 : s.key) !== null && o !== void 0 ? o : null);
        }
        l = this.collection.getKeyAfter(l);
      }
    };
    return e(this.collection.getFirstKey()), t;
  }
  /**
  * Selects all items in the collection.
  */
  selectAll() {
    !this.isSelectAll && this.selectionMode === "multiple" && this.state.setSelectedKeys("all");
  }
  /**
  * Removes all keys from the selection.
  */
  clearSelection() {
    !this.disallowEmptySelection && (this.state.selectedKeys === "all" || this.state.selectedKeys.size > 0) && this.state.setSelectedKeys(new n());
  }
  /**
  * Toggles between select all and an empty selection.
  */
  toggleSelectAll() {
    this.isSelectAll ? this.clearSelection() : this.selectAll();
  }
  select(t, e) {
    this.selectionMode !== "none" && (this.selectionMode === "single" ? this.isSelected(t) && !this.disallowEmptySelection ? this.toggleSelection(t) : this.replaceSelection(t) : this.selectionBehavior === "toggle" || e && (e.pointerType === "touch" || e.pointerType === "virtual") ? this.toggleSelection(t) : this.replaceSelection(t));
  }
  /**
  * Returns whether the current selection is equal to the given selection.
  */
  isSelectionEqual(t) {
    if (t === this.state.selectedKeys) return !0;
    let e = this.selectedKeys;
    if (t.size !== e.size) return !1;
    for (let l of t)
      if (!e.has(l)) return !1;
    for (let l of e)
      if (!t.has(l)) return !1;
    return !0;
  }
  canSelectItem(t) {
    var e;
    if (this.state.selectionMode === "none" || this.state.disabledKeys.has(t)) return !1;
    let l = this.collection.getItem(t);
    return !(!l || !(l == null || (e = l.props) === null || e === void 0) && e.isDisabled || l.type === "cell" && !this.allowsCellSelection);
  }
  isDisabled(t) {
    var e, l;
    return this.state.disabledBehavior === "all" && (this.state.disabledKeys.has(t) || !!(!((l = this.collection.getItem(t)) === null || l === void 0 || (e = l.props) === null || e === void 0) && e.isDisabled));
  }
  isLink(t) {
    var e, l;
    return !!(!((l = this.collection.getItem(t)) === null || l === void 0 || (e = l.props) === null || e === void 0) && e.href);
  }
  getItemProps(t) {
    var e;
    return (e = this.collection.getItem(t)) === null || e === void 0 ? void 0 : e.props;
  }
  withCollection(t) {
    return new h(t, this.state, {
      allowsCellSelection: this.allowsCellSelection,
      layoutDelegate: this.layoutDelegate || void 0
    });
  }
  constructor(t, e, l) {
    this.collection = t, this.state = e;
    var s;
    this.allowsCellSelection = (s = l == null ? void 0 : l.allowsCellSelection) !== null && s !== void 0 ? s : !1, this._isSelectAll = null, this.layoutDelegate = (l == null ? void 0 : l.layoutDelegate) || null;
  }
}
export {
  h as SelectionManager
};
