import { NumberFormatter as C } from "./ui-components-library373.js";
const M = new RegExp("^.*\\(.*\\).*$"), V = [
  "latn",
  "arab",
  "hanidec",
  "deva",
  "beng"
];
class j {
  /**
  * Parses the given string to a number. Returns NaN if a valid number could not be parsed.
  */
  parse(i) {
    return f(this.locale, this.options, i).parse(i);
  }
  /**
  * Returns whether the given string could potentially be a valid number. This should be used to
  * validate user input as the user types. If a `minValue` or `maxValue` is provided, the validity
  * of the minus/plus sign characters can be checked.
  */
  isValidPartialNumber(i, e, t) {
    return f(this.locale, this.options, i).isValidPartialNumber(i, e, t);
  }
  /**
  * Returns a numbering system for which the given string is valid in the current locale.
  * If no numbering system could be detected, the default numbering system for the current
  * locale is returned.
  */
  getNumberingSystem(i) {
    return f(this.locale, this.options, i).options.numberingSystem;
  }
  constructor(i, e = {}) {
    this.locale = i, this.options = e;
  }
}
const y = /* @__PURE__ */ new Map();
function f(r, i, e) {
  let t = $(r, i);
  if (!r.includes("-nu-") && !t.isValidPartialNumber(e)) {
    for (let n of V) if (n !== t.options.numberingSystem) {
      let l = $(r + (r.includes("-u-") ? "-nu-" : "-u-nu-") + n, i);
      if (l.isValidPartialNumber(e)) return l;
    }
  }
  return t;
}
function $(r, i) {
  let e = r + (i ? Object.entries(i).sort((n, l) => n[0] < l[0] ? -1 : 1).join() : ""), t = y.get(e);
  return t || (t = new A(r, i), y.set(e, t)), t;
}
class A {
  parse(i) {
    let e = this.sanitize(i);
    if (this.symbols.group && (e = c(e, this.symbols.group, "")), this.symbols.decimal && (e = e.replace(this.symbols.decimal, ".")), this.symbols.minusSign && (e = e.replace(this.symbols.minusSign, "-")), e = e.replace(this.symbols.numeral, this.symbols.index), this.options.style === "percent") {
      let o = e.indexOf("-");
      e = e.replace("-", "");
      let a = e.indexOf(".");
      a === -1 && (a = e.length), e = e.replace(".", ""), a - 2 === 0 ? e = `0.${e}` : a - 2 === -1 ? e = `0.0${e}` : a - 2 === -2 ? e = "0.00" : e = `${e.slice(0, a - 2)}.${e.slice(a - 2)}`, o > -1 && (e = `-${e}`);
    }
    let t = e ? +e : NaN;
    if (isNaN(t)) return NaN;
    if (this.options.style === "percent") {
      var n, l;
      let o = {
        ...this.options,
        style: "decimal",
        minimumFractionDigits: Math.min(((n = this.options.minimumFractionDigits) !== null && n !== void 0 ? n : 0) + 2, 20),
        maximumFractionDigits: Math.min(((l = this.options.maximumFractionDigits) !== null && l !== void 0 ? l : 0) + 2, 20)
      };
      return new j(this.locale, o).parse(new C(this.locale, o).format(t));
    }
    return this.options.currencySign === "accounting" && M.test(i) && (t = -1 * t), t;
  }
  sanitize(i) {
    return i = i.replace(this.symbols.literals, ""), this.symbols.minusSign && (i = i.replace("-", this.symbols.minusSign)), this.options.numberingSystem === "arab" && (this.symbols.decimal && (i = i.replace(",", this.symbols.decimal), i = i.replace("،", this.symbols.decimal)), this.symbols.group && (i = c(i, ".", this.symbols.group))), this.options.locale === "fr-FR" && (i = c(i, ".", " ")), i;
  }
  isValidPartialNumber(i, e = -1 / 0, t = 1 / 0) {
    return i = this.sanitize(i), this.symbols.minusSign && i.startsWith(this.symbols.minusSign) && e < 0 ? i = i.slice(this.symbols.minusSign.length) : this.symbols.plusSign && i.startsWith(this.symbols.plusSign) && t > 0 && (i = i.slice(this.symbols.plusSign.length)), this.symbols.group && i.startsWith(this.symbols.group) || this.symbols.decimal && i.indexOf(this.symbols.decimal) > -1 && this.options.maximumFractionDigits === 0 ? !1 : (this.symbols.group && (i = c(i, this.symbols.group, "")), i = i.replace(this.symbols.numeral, ""), this.symbols.decimal && (i = i.replace(this.symbols.decimal, "")), i.length === 0);
  }
  constructor(i, e = {}) {
    this.locale = i, this.formatter = new Intl.NumberFormat(i, e), this.options = this.formatter.resolvedOptions(), this.symbols = W(i, this.formatter, this.options, e);
    var t, n;
    this.options.style === "percent" && (((t = this.options.minimumFractionDigits) !== null && t !== void 0 ? t : 0) > 18 || ((n = this.options.maximumFractionDigits) !== null && n !== void 0 ? n : 0) > 18) && console.warn("NumberParser cannot handle percentages with greater than 18 decimal places, please reduce the number in your options.");
  }
}
const S = /* @__PURE__ */ new Set([
  "decimal",
  "fraction",
  "integer",
  "minusSign",
  "plusSign",
  "group"
]), T = [
  0,
  4,
  2,
  1,
  11,
  20,
  3,
  7,
  100,
  21,
  0.1,
  1.1
];
function W(r, i, e, t) {
  var n, l, o, a;
  let d = new Intl.NumberFormat(r, {
    ...e,
    // Resets so we get the full range of symbols
    minimumSignificantDigits: 1,
    maximumSignificantDigits: 21,
    roundingIncrement: 1,
    roundingPriority: "auto",
    roundingMode: "halfExpand"
  }), u = d.formatToParts(-10000.111), N = d.formatToParts(10000.111), x = T.map((s) => d.formatToParts(s));
  var p;
  let w = (p = (n = u.find((s) => s.type === "minusSign")) === null || n === void 0 ? void 0 : n.value) !== null && p !== void 0 ? p : "-", h = (l = N.find((s) => s.type === "plusSign")) === null || l === void 0 ? void 0 : l.value;
  !h && ((t == null ? void 0 : t.signDisplay) === "exceptZero" || (t == null ? void 0 : t.signDisplay) === "always") && (h = "+");
  let F = (o = new Intl.NumberFormat(r, {
    ...e,
    minimumFractionDigits: 2,
    maximumFractionDigits: 2
  }).formatToParts(1e-3).find((s) => s.type === "decimal")) === null || o === void 0 ? void 0 : o.value, v = (a = u.find((s) => s.type === "group")) === null || a === void 0 ? void 0 : a.value, D = u.filter((s) => !S.has(s.type)).map((s) => P(s.value)), I = x.flatMap((s) => s.filter((m) => !S.has(m.type)).map((m) => P(m.value))), g = [
    .../* @__PURE__ */ new Set([
      ...D,
      ...I
    ])
  ].sort((s, m) => m.length - s.length), E = g.length === 0 ? new RegExp("[\\p{White_Space}]", "gu") : new RegExp(`${g.join("|")}|[\\p{White_Space}]`, "gu"), b = [
    ...new Intl.NumberFormat(e.locale, {
      useGrouping: !1
    }).format(9876543210)
  ].reverse(), R = new Map(b.map((s, m) => [
    s,
    m
  ])), _ = new RegExp(`[${b.join("")}]`, "g");
  return {
    minusSign: w,
    plusSign: h,
    decimal: F,
    group: v,
    literals: E,
    numeral: _,
    index: (s) => String(R.get(s))
  };
}
function c(r, i, e) {
  return r.replaceAll ? r.replaceAll(i, e) : r.split(i).join(e);
}
function P(r) {
  return r.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
}
export {
  j as NumberParser
};
