import { default as React } from 'react';
import { ButtonProps as AriaButtonProps } from 'react-aria-components';
export interface BaseButtonProps {
    variant?: "primary" | "secondary" | "tertiary";
    small?: boolean;
    isLoading?: boolean;
}
export interface ButtonProps extends AriaButtonProps, Omit<BaseButtonProps, "$loading"> {
    text: string;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    icon?: React.ReactNode;
    className?: string;
}
declare function Button({ text, variant, Icon, icon, isLoading, className, isDisabled, ...props }: Readonly<ButtonProps>): React.ReactElement;
export default Button;
