import { default as React } from 'react';
import { default as BigNumber } from 'bignumber.js';
export interface FormatOptions {
    prefix?: string;
    decimalSeparator?: string;
    groupSeparator?: string;
    groupSize?: number;
    secondaryGroupSize?: number;
    fractionGroupSeparator?: string;
    fractionGroupSize?: number;
    suffix?: string;
}
export interface BigNumberFieldProps {
    value?: string | BigNumber;
    defaultValue?: string | BigNumber;
    minValue?: string | BigNumber;
    maxValue?: string | BigNumber;
    step?: string | BigNumber;
    onChange?: (value: BigNumber) => void;
    isDisabled?: boolean;
    isReadOnly?: boolean;
    isRequired?: boolean;
    isWheelDisabled?: boolean;
    id?: string;
    label?: string;
    description?: string;
    errorMessage?: string;
    placeholder?: string;
    formatOptions?: FormatOptions;
    inputProps?: React.InputHTMLAttributes<HTMLInputElement>;
}
export declare function useBigNumberField(props: BigNumberFieldProps): {
    inputProps: React.InputHTMLAttributes<HTMLInputElement>;
    labelProps: {
        htmlFor: string | undefined;
    };
    incrementButtonProps: {
        type: "button";
        "aria-label": string;
        "aria-controls": string | undefined;
        slot: string;
        isDisabled: boolean;
        onPress: () => void;
    };
    decrementButtonProps: {
        type: "button";
        "aria-label": string;
        "aria-controls": string | undefined;
        slot: string;
        isDisabled: boolean;
        onPress: () => void;
    };
    groupProps: {
        "aria-disabled": true | undefined;
    };
    descriptionProps: {
        id: string | undefined;
        slot: string;
    };
    errorMessageProps: {
        id: string | undefined;
    };
    inputValue: string;
    numberValue: BigNumber | null;
    canIncrement: boolean;
    canDecrement: boolean;
};
