import { default as React, ReactNode } from 'react';
import { TabsProps as AriaTabsProps, Key, TabListProps, TabPanelProps, TabProps } from 'react-aria-components';
interface TabsItem {
    id: Key;
    text: string;
    value: any;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    icon?: React.ReactNode;
    disabled?: boolean;
    content: ReactNode;
    tabProps?: TabProps;
    tabPanelProps?: TabPanelProps;
}
interface TabsProps extends Omit<AriaTabsProps, "orientation"> {
    items: TabsItem[];
    callback?: (key: Key, value: TabsItem["value"]) => void;
    className?: string;
    panelClassName?: string;
    tabListProps?: TabListProps<TabProps>;
}
declare function Tabs({ items, className, tabListProps, panelClassName, callback, defaultSelectedKey, ...props }: Readonly<TabsProps>): React.JSX.Element;
export default Tabs;
