import { default as React } from 'react';
import { VariantProp } from './spine';
export type { VariantProp };
export interface SideProp {
    rightSided?: boolean;
}
export interface StateProp {
    state?: "loading" | "disabled" | "active";
}
interface BulletProps extends VariantProp, SideProp, StateProp {
    title: string;
    party: string | React.ReactElement;
    subtitle: string;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
    line?: boolean;
    isLast: boolean;
    className?: string;
}
declare const Bullet: React.FC<BulletProps>;
export default Bullet;
