import { default as React } from 'react';
import { StateProp, VariantProp } from './bullet';
interface TimelineItem extends VariantProp, StateProp {
    title: string;
    party: string | React.ReactElement;
    subtitle: string;
    Icon?: React.FC<React.SVGAttributes<SVGElement>>;
}
interface ICustomTimelineProps {
    items: [TimelineItem, ...TimelineItem[]];
    className?: string;
}
declare function CustomTimeline({ items, className, ...props }: Readonly<ICustomTimelineProps>): React.JSX.Element;
export default CustomTimeline;
