import { default as React } from 'react';
import { TooltipTriggerComponentProps, TooltipProps as AriaTooltipProps, OverlayArrowProps } from 'react-aria-components';
export interface TooltipBaseProps extends TooltipTriggerComponentProps {
    place?: "left" | "right" | "top" | "bottom";
    small?: boolean;
    tooltipProps?: AriaTooltipProps;
    overlayArrowProps?: OverlayArrowProps;
    wrapperProps?: React.HTMLAttributes<HTMLDivElement>;
}
interface TooltipProps extends TooltipBaseProps {
    text: string;
    className?: string;
}
declare function Tooltip({ place, text, children, small, className, delay, ...props }: Readonly<TooltipProps>): React.JSX.Element;
export default Tooltip;
